;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Effect Name : 960 delay for compressor application
;
; Description : Delays the signal by 960 samples
;
; Nb In       : 1
; Nb Out      : 1
;
; Input       : audio signal
; Output      : delayed audio signal
;
; Cycles      : 9 + 7 cycles (-1=unknownw)
; Memory      : 962 words (without init)
; Delay Line  : no
;
; Author      : Lall
; Date        : 10/05/2004
; Version     : 1.0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ABS     INIT    0x3FF

        ;; SEC1 Control parameters
;none


        ;; SEC2 Initial values of control parameters (S3.24 format)
; none


        ;; SEC3 Constants definitions
; none


        ;; SEC4 Memory variables definition
ABS	DelPtr	0x0			; The current input delay position is stored here
ABS	DelBeg  0x1			; Start of the delay line
ABS DelEnd	0x3C1   	; End of the delay line

        ;; SEC5 Initial values of memory variables
IDel  	EQU 0.0				; {0,1,log}

        ;; SEC6 Initialization
CM      0x40000 INIT
SKIP    !Z      EndInit
CM      0.0     INIT
1AC		0x3BF
SCA		0x0		DelPtr		; init the current delay pointer
DAC     0x0     0x40000     ; 1->A
SCA     0x0     INIT        ; do not reinitialize next time
EndInit:
	
        ;; SEC7 Module code
LCM		1.0		DelPtr		; DelPtr -> B
LINDF	0x3FF	DelBeg		; Read from the delay line
SCA		0.0		OUT1		; Store the value at the output

CM		1.0		IN1			; Load the input
SINDF	0x3FF	DelBeg		; Store the input in the delay line

1BC		0xFFFFFFF			; B-1 -> A
SKIP	!N		1
C	   	0x3BF				; reload the delay length
SCA		0.0		DelPtr
