//--------------------------------------------------------------------//
//  AgALag : Axoris group AL3101 application generator                //
//                                                                    //
//                 _         _    _      _                            //
//                / \____   / \  | |    / \____                       //
//               / _ \  _\ / _ \ | |   / _ \  _\                      //
//              / /_\ \  __ /_\ \| |  / /_\ \  __                     //
//             / _____ \ \ \____ \ |_/______ \ \ \                    //
//            /_/     \_\___\   \_\____|    \_\___\                   //
//                                                                    //
//  File: memory.h                                                    //
//  Description: functions dealing with memory offsets                //
//  Version: 1.0                                                      //
//  Author: Gregor                                                    //
//  e-mail: Gregor.Soyez@swing.be                                     //
//                                                                    //
//  Copyright (C) 2002 Axoris                                         //
//--------------------------------------------------------------------//
#ifndef __PROJ_AL_MEMORY_H__
#define __PROJ_AL_MEMORY_H__

/* 
** initialize the memory allocating stuff
*/
int MemAllocInit();

/*
** the following function retreive an offset
** for a memory segment of given length
** It allocates memory starting from the beginning
** thus if some delay-line requires the first memory
** segment, you have to call the SegAlloc function
** for that segment before any other one
** -1 if there is not enough memory
*/
int SegAlloc(int Size);

#endif
