#include "map.h"
#include "../asm/base/asmfunc.h" // contain ExtractHexa function
#include "messages.h"
#include "properties.h"
#include <string.h>
#include <stdio.h>

int GenerateOffsetTable(char *ProjectFile, CCodeModule **Mods, int NbMods){
  int i,j;
  char name[255];
  FILE *mapflux;

  // write map
  strcpy(name, ProjectFile);
  j = strlen(ProjectFile);
  name[j-3] = 'o';
  name[j-2] = 'f';
  name[j-1] = 'f';
  mapflux = fopen(name, "w+");

  // catch definitions in each module.
  // note that most of the work is done when building properties
  // we just need to convert strings to numerical values.
  for (i=0;i<NbMods;i++){
    if ((strcmp(Mods[i]->Name, "IN")==0) || (strcmp(Mods[i]->Name, "OUT")==0)){
      VERBOSE("Skipping IN & OUT modules\n");
      continue;
    }
    VERBOSE2("  module %s:%d\n", Mods[i]->Name, Mods[i]->GetMemOffset());
    fprintf(mapflux, "%d:%s:%s:%d\n", Mods[i]->Index, Mods[i]->Label, Mods[i]->Name, Mods[i]->GetMemOffset());
  }

  fclose(mapflux);
  return 0;
}
