#include <string.h>
#include <stdio.h>
#include "PreAsm.h"
#include "Format.h"
#include "DbgFiles.h"

/*
** writes assembled result to
** object file
*/
int Convert2String(UINT32 val, char *res){
  char OutChar=0;
  UINT32 t;
  int i;

  for (i=0;i<7;i++){
    t= (val >> (4*i))%0x10;
    if (t<=9)
      OutChar='0'+(char) t;
    else
      OutChar='A'+(char) (t-10);
    res[6-i]=OutChar;
  }
  res[7]='\0';

  return 0;
}


// creates a memory map file from 
// the PAsmCst informations found in Preassembler
// For each ABS instruction <Name> (type CST_ABS), 
// we search an CST_EQU definition <IName>
// If this is not present, we set value to 0.
// we return 0 when successfull and 1 when
// error occured
int GenerateMap(FILE *map){
  int i, j, noval;
  char InitVal[255];

  UINT32 Mem[1024];
  UINT32 addr, val;

  // initialize mem to 0
  for (i=0;i<1024;i++) Mem[i]=(UINT32) 0;

  // browse the Constant table from PreAssembler
  for (i=0;i<AL3101PreAsmNbCst;i++){
    // check if this is a address definition
    if (AL3101PreAsmCstTable[i].Type==CST_ABS){
      // get numerical value for address
      ExtractHexa(AL3101PreAsmCstTable[i].StrValue, 
		  &addr, 
		  NMANT_ADDR);
      
      if (addr<0x400){
	// compute the constant name for init val
	sprintf(InitVal, "I%s", AL3101PreAsmCstTable[i].Name);
	
	// search this guy!
	noval=1;
	for (j=0;j<AL3101PreAsmNbCst;j++){
	  if ((AL3101PreAsmCstTable[j].Type==CST_EQU) 
	      && strcmp(AL3101PreAsmCstTable[j].Name, InitVal)==0){
	    // we have found a corresponding initial value
	    // it is supposed in S3.24 format !
	    noval = ExtractHexa(AL3101PreAsmCstTable[j].StrValue, 
				&val, 
				24);
	  }
	}
	if (!noval) Mem[(int) addr]=val;
      }
    }
  }
  
  // write file
  for (i=0;i<1024;i++){
    Convert2String(Mem[i], InitVal);
    fprintf(map, "%s\n", InitVal);
  }

  return 0;
}
