#include "option.h"

#ifdef WIN32

#include <string.h>

/*
** if an option needs an argument, it is returned
** through this pointer.
*/
char *optarg=NULL;

/*
** this indicates the index in ARGV of the last 
** treated argument.
*/
char optind=0;

char getopt(int argc, char *argv[], char *optstring){
  int i, j;
  char dash_opt[3];
  char *tmp;

  // we do not touch to the already-parsed arguments
  i=optind+1;
  dash_opt[0]='-';
  dash_opt[2]='\0';
  while (i<argc){
    // check if the ih argument corresponds to an option.
    if (argv[i][0]=='-'){
      //fprintf(stdout, "scanning arg %d\n", i);
      j=0;
      // browse argument list.
      while (j<strlen(optstring)){
	dash_opt[1]=optstring[j];
	if ((optstring[j]!=':') && (strcmp(argv[i], dash_opt)==0)){
	  // invert ARGV order increment optind
	  optind++;
	  tmp=argv[i];
	  argv[i]=argv[optind];
	  argv[optind]=tmp;
	  // check if an argument must be associated
	  if ((j<strlen(optstring)-1) && (optstring[j+1]==':')){
	    // check validity of the argument 
	    // (i.e. next element in ARGV doesn't start with '-'
	    if ((i==argc-1) || ((i<argc-1) && (argv[i+1][0]=='-'))) return ':';
	    // invert ARGV order increment optind
	    optind++;
	    tmp=argv[i+1];
	    argv[i+1]=argv[optind];
	    optarg=argv[optind]=tmp;
	  }
	  return optstring[j];
	}
      j++;
      }
      return '?';
    }
    i++;
  }

  return (char) -1;
}

#endif
