// FileIO_DEC.h: interface for the DEC File functions.
//
//////////////////////////////////////////////////////////////////////

#ifndef __AL3101__FILEIO_DEC__H__
#define __AL3101__FILEIO_DEC__H__

#include <stdio.h>							// for the file IO
#include "../../../common/1K_types.h"		// for the simulator types
#include "./../FileIO_Generic.h"			// for the definition of the generic file IO stuff


//////////////////////////////////
// definition of the prototypes
//////////////////////////////////
// init & clean functions
INT32 FileIO_DEC_Init(void **pInst, CHAR *FileName, INT32 Mode, FileIO_SndCfg *cfg, INT32 *LeftSampleMemory, INT32 *RightSampleMemory = NULL);
INT32 FileIO_DEC_Clean(void *pInst);

// "processing" functions
INT32 FileIO_DEC_ReadSample(void *pInst);
INT32 FileIO_DEC_WriteSample(void *pInst);

// file functions
INT32 FileIO_DEC_GetPosition(void *pInstance, INT32 *CurrentPosition);
INT32 FileIO_DEC_GetFileLength(void *pInstance, INT32 *FileSize);

// control functions
INT32 FileIO_DEC_SetLoopingMode(void *pInst, INT32 Looping);

// text functions
void FileIO_DEC_GetLastErrorString(CHAR *str, INT32 LastErrorCode, INT32 MaxNumberOfCharacters);
void FileIO_DEC_GetHelp(CHAR *str, INT32 LineNumber, INT32 MaxNumberOfCharacters);


//////////////////////////////////
// defines DEC error messages
//////////////////////////////////
#define FILEIO_DEC_NOERROR					(FILEIO_DEC_BASE_ERR +  0)


#endif // !defined(__AL3101__FILEIO_DEC__H__)
