// FileIO_Generic.cpp: implementation of the generic File functions.
//
//////////////////////////////////////////////////////////////////////

#include "FileIO_Generic.h"

#include <string.h>		// for the strncpy function


//////////////////////////////////////////////////////////////////////
// "text" function(s)
//////////////////////////////////////////////////////////////////////
void FileIO_GetLastErrorString(CHAR *str, INT32 LastErrorCode, INT32 MaxNumberOfCharacters)
{
	if ((LastErrorCode & FILEIO_BASE_ERR) == FILEIO_BASE_ERR)		// check if the error is a FileIO error
	{
		if ((LastErrorCode & FILEIO_GEN_BASE_ERR) == FILEIO_GEN_BASE_ERR)
		{
			// do nothing here, wait for the switch below
		}
		else
		{
			strncpy(str, "Error type not known", MaxNumberOfCharacters - 1);
		}
	}
	else															// this error is not a FileIO error
	{
		strncpy(str, "Not a FileIO error", MaxNumberOfCharacters - 1);
		return;
	}


	switch(LastErrorCode)
	{
		case FILEIO_NOERROR:
			strncpy(str, "No error occurred", MaxNumberOfCharacters - 1);
			break;
		case FILEIO_CANNOT_ALLOCATE_INSTANCE:
			strncpy(str, "Cannot allocate instance memory", MaxNumberOfCharacters - 1);
			break;
		case FILEIO_TYPE_NOT_SUPPORTED:
			strncpy(str, "File type is not supported", MaxNumberOfCharacters - 1);
			break;
		case FILEIO_CANNOT_OPEN_FILE:
			strncpy(str, "Unable to open file", MaxNumberOfCharacters - 1);
			break;
		case FILEIO_CANNOT_CLOSE_FILE:
			strncpy(str, "Unable to close file", MaxNumberOfCharacters - 1);
			break;
		case FILEIO_WRONG_FILE_MODE:
			strncpy(str, "Wrong file access mode", MaxNumberOfCharacters - 1);
			break;
		case FILEIO_READ_ERROR:
			strncpy(str, "File read error", MaxNumberOfCharacters - 1);
			break;
		case FILEIO_WRITE_ERROR:
			strncpy(str, "File write error", MaxNumberOfCharacters - 1);
			break;
		case FILEIO_EOF_REACHED:
			strncpy(str, "End of file reached", MaxNumberOfCharacters - 1);
			break;
		case FILEIO_CANNOT_GET_POSITION:
			strncpy(str, "Cannot get current position", MaxNumberOfCharacters - 1);
			break;
		case FILEIO_PROBLEM_WHILE_SEEKING:
			strncpy(str, "Unable to seek into the file", MaxNumberOfCharacters - 1);
			break;
		case FILEIO_INSTANCE_NOT_INITIALIZED:
			strncpy(str, "Instance not initialized", MaxNumberOfCharacters - 1);
			break;
		case FILEIO_WRONG_CHANNEL_NUMBER:
			strncpy(str, "Wrong number of channels in file", MaxNumberOfCharacters - 1);
			break;
		default:
			strncpy(str, "Error not known", MaxNumberOfCharacters - 1);
			break;
	}
}

